/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000 Sakai Hiroaki.                              */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Explosion 饹(ȯѤΥ饹)Υ饤֥                        */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "ExplosionP.h"

/*****************************************************************************/
/* ؿ                                                                */
/*****************************************************************************/

/*===========================================================================*/
/* ѿμ                                                          */
/*===========================================================================*/

Tank ExplosionGetTank(Explosion explosion) { return (explosion->tank); }

/*===========================================================================*/
/* ȯϰ⤫ɤΥå                                            */
/*===========================================================================*/

int ExplosionCheck(Explosion explosion, double x, double y)
{
  double dx, dy, r;

  dx = x - explosion->x;
  dy = y - explosion->y;
  r = (double)number_to_radius[counter_to_number[explosion->counter]]
    * (1.0 / EXPLOSION_SIZE);

  return (dx * dx + dy * dy <= r * r);
}

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Explosion ExplosionCreate(double x, double y, Tank tank, int state)
{
  Explosion explosion;

  explosion = (Explosion)malloc(sizeof(_Explosion));
  if (explosion == NULL) ErrorExit("Cannot create canon.");

  explosion->x = x;
  explosion->y = y;
  explosion->tank = tank;
  explosion->state = state;
  explosion->counter = 0;

  return (explosion);
}

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Explosion ExplosionDestroy(Explosion explosion)
{
  if (explosion == NULL) return (NULL);

  free(explosion);

  return (NULL);
}

/*===========================================================================*/
/* ȯ                                                                      */
/*===========================================================================*/

int ExplosionAct(Explosion explosion)
{
  switch (explosion->state) {
  case EXPLOSION_WAIT :
    break;
  case EXPLOSION_ACTIVE :
    (explosion->counter)++;
    if (explosion->counter >= EXPLOSION_COUNTER_NUMBER)
      explosion->state = EXPLOSION_DESTROY;
    break;
  case EXPLOSION_DESTROY :
    break;
  }
  return (explosion->state);
}

/*===========================================================================*/
/* ǡ                                                            */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ѥǡκ                                                        */
/*---------------------------------------------------------------------------*/

char * ExplosionMakeDrawData(Explosion explosion, char * p)
{
  if (!explosion) return (NULL);
  if (!p        ) return (NULL);

  if (explosion->state != EXPLOSION_ACTIVE) return (p);

  sprintf(p, EXPLOSION_DRAW "\t%3.1f %3.1f %d\n",
          explosion->x, explosion->y, counter_to_number[explosion->counter]);

  while (*(p++) != '\n') { /* None */ }
  *p = '\0';

  return (p);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
