/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000 Sakai Hiroaki.                              */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* Stage 饹(ơΥ饹)Υ饤֥()                  */
/*****************************************************************************/

#ifndef _NADAR_SHARE_STAGE_H_INCLUDED_
#define _NADAR_SHARE_STAGE_H_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

typedef struct _Stage * Stage; /* Stage 饹 */

#include "configure.h"

#include "etc.h"
#include "Substance.h"
#include "Map.h"
#include "Player.h"
#include "Tank.h"
#include "Canon.h"
#include "Missile.h"
#include "Explosion.h"

/*===========================================================================*/
/* ѿμ                                                    */
/*===========================================================================*/

Map StageGetMap(Stage s);
SubstanceList StageGetTankList(     Stage s);
SubstanceList StageGetCanonList(    Stage s);
SubstanceList StageGetMissileList(  Stage s);
SubstanceList StageGetExplosionList(Stage s);

/*===========================================================================*/
/* ֥ȤȺ                                                  */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ֥Ȥ                                                        */
/*---------------------------------------------------------------------------*/

Stage StageCreate(int stage_number, SubstanceList player_list);

/*---------------------------------------------------------------------------*/
/* ֥Ȥκ                                                        */
/*---------------------------------------------------------------------------*/

Stage StageDestroy(Stage stage);

/*===========================================================================*/
/* ơγ(ФΥᥤ롼)                                      */
/*===========================================================================*/

int StageStartAsServer(Stage stage, SubstanceList player_list, Path request);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif /* _NADAR_SHARE_STAGE_H_INCLUDED_ */

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
