/*****************************************************************************/
/* N.A.D.A.R. - A network tank battle game.                                  */
/*                                                                           */
/* N.A.D.A.R. Copyright (c) 2000 Sakai Hiroaki.                              */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* N.A.D.A.R. is a network tank battle game. You get into a tank,            */
/* operate it, and destroy other tanks to survive!                           */
/*****************************************************************************/

/*****************************************************************************/
/* ¾δؿΥ饤֥                                                  */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

#include "etc.h"

/*---------------------------------------------------------------------------*/
/* 顼ǽλ                                                              */
/*---------------------------------------------------------------------------*/

void ErrorExit(char * s)
{
  fprintf(stderr, "Error : %s\n", s);
  exit (1);
}

/*---------------------------------------------------------------------------*/
/* ν                                                              */
/*---------------------------------------------------------------------------*/

void InitializeRandom()
{
  time_t t;

  time(&t);
  srand(t);
}

/*---------------------------------------------------------------------------*/
/* μ                                                                */
/*---------------------------------------------------------------------------*/

int GetRandomValue(int n)
{
  return ((rand() / 16) % n);
}

/*---------------------------------------------------------------------------*/
/* ɸѴ                                                                */
/*---------------------------------------------------------------------------*/

int ConvertXFromPositionToMap(double x) { return ((int)(x + 5) - 5); }
int ConvertYFromPositionToMap(double y) { return ((int)(y + 5) - 5); }

int ConvertXFromPositionToDisplay(double x, int ratio)
{ return (((int)(x * CHARACTER_SIZE + 5.5) - 5) * ratio / 100); }
int ConvertYFromPositionToDisplay(double y, int ratio)
{ return (((int)(y * CHARACTER_SIZE + 5.5) - 5) * ratio / 100); }

int ConvertXFromMapToDisplay(double x, int ratio)
{ return (x * CHARACTER_SIZE * ratio / 100); }
int ConvertYFromMapToDisplay(double y, int ratio)
{ return (y * CHARACTER_SIZE * ratio / 100); }

/*---------------------------------------------------------------------------*/
/* κ                                                                */
/*---------------------------------------------------------------------------*/

int DeleteArgument(int * argcp, char * argv[], int n)
{
  if (n < 1 || n > *argcp - 1) return (1);

  for (; n < *argcp - 1; n++) {
    argv[n] = argv[n + 1];
  }
  argv[n] = NULL;
  (*argcp)--;

  return (0);
}

/*===========================================================================*/
/* μ                                                                */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/* ʸȤƼ                                                          */
/*---------------------------------------------------------------------------*/

char * GetArgument(int * argcp, char * argv[], char * arg)
{
  int i;
  char * p = NULL;

  for (i = 1; i < *argcp; i++) {
    if (!strcmp(argv[i], arg)) {
      DeleteArgument(argcp, argv, i);
      if (i < *argcp) {
	p = argv[i];
	DeleteArgument(argcp, argv, i);
      }
      i--;
    }
  }
  return (p);
}

/*---------------------------------------------------------------------------*/
/* ͤȤƼ                                                          */
/*---------------------------------------------------------------------------*/

int GetArgumentByIntegerValue(int * argcp, char * argv[], char * arg)
{
  char * p;

  p = GetArgument(argcp, argv, arg);
  if (p == NULL) return (-1);

  return (atoi(p));
}

/*---------------------------------------------------------------------------*/
/* ֡ꥢͤȤƼ                                                    */
/*---------------------------------------------------------------------------*/

int GetArgumentByBoolean(int * argcp, char * argv[], char * arg)
{
  int i;
  int ret = 0;

  for (i = 1; i < *argcp; i++) {
    if (!strcmp(argv[i], arg)) {
      DeleteArgument(argcp, argv, i);
      ret = 1;
    }
  }
  return (ret);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
